/*
 Copyright (c) Information Equipment co.,LTD.
 All right reserved.
 
 Code by JaeHyuk Cho <mailto:minzkn@infoeq.com> Made in KOREA

 http://minzkn.pe.ky
*/

#ifndef DEF_SOURCE_hook_c 
#define DEF_SOURCE_hook_c "hook.c"

#include <stdlib.h>

#include "mz.h"

void *MZ_Alloc(int s_AllocateSize);
void MZ_Free(void *s_AllocMemory);
int MZ_AllocSize(void);
int MZ_AllocCount(void);

static int __g_HOOK_AllocateMemorySize__ = 0, __g_HOOK_AllocateMemoryCount__ = 0;

/* [ Static function ] ==================================================================== */

/* [ Public function ] ==================================================================== */
void *MZ_Alloc(int s_AllocateSize)
{
 void *s_AllocMemory;	
 if(s_AllocateSize > 0)
 {
  s_AllocMemory = (void *)malloc((size_t)(s_AllocateSize + sizeof(s_AllocateSize)));
  if(s_AllocMemory)
  {
   *(((int *)s_AllocMemory)++) = s_AllocateSize;
   MZ_AtomicAdd(&__g_HOOK_AllocateMemorySize__, s_AllocateSize);
   MZ_AtomicAdd(&__g_HOOK_AllocateMemoryCount__, 1);
   return(s_AllocMemory);
  }
 }
 return((void *)0);
}

void MZ_Free(void *s_AllocMemory)
{
 if(s_AllocMemory)
 {
  MZ_AtomicSub(&__g_HOOK_AllocateMemorySize__, *(--((int *)s_AllocMemory)));
  MZ_AtomicSub(&__g_HOOK_AllocateMemoryCount__, 1);
  free((void *)s_AllocMemory);
 }
}

int MZ_AllocSize(void)
{
 return(__g_HOOK_AllocateMemorySize__);
}

int MZ_AllocCount(void)
{
 return(__g_HOOK_AllocateMemoryCount__);
}

#endif

/* End of source */
