/* 
 Copyright (c) 2004 JaeHyuk Cho <mailto:minzkn@infoeq.com>
 All right reserved.
*/

/* 
 x86 machine's master boot code
*/

.code16
.org 0x0000
L_Entry:
	cli
	movw %cs, %ax
	movw %ax, %ds
	callw 0f
0:
	popw %si
	subw $(0b - L_Entry), %si
	movw $0x0050, %ax
	movw %ax, %es
	xorw %di, %di
	cld
	movw $(512 / 2), %cx
	repz movsw %ds:(%si), %es:(%di)
	ljmp $0x0050, $0f
0:	
	movw %ax, %ds
	movw %ax, %ss
	movw $(512 + 512), %sp  
	callw P_ResetDisk

	movw $L_PartitionTable_Start, %si
0:
	cmpb $0x80, (%si)
	je 0f
	addw $0x10, %si
	cmpw $L_PartitionTable_End, %si
	jb 0b /* Carry == 1 ? jump 0b : next (>) */
	movw $1f, %si
	callw P_Error
1:
	.string "Not found active partition !\r\n"
0:

	movw $0x07c0, %ax
	movw %ax, %es
	movw $0x0201, %ax
	xorw %bx, %bx
	movw 0x02(%si), %cx
	movw 0x00(%si), %dx
	int $0x13
	jnc 0f
	movw $1f, %si
	callw P_Error
1:
	.string "Can not load !\r\n"
0:

	callw P_UserCode

	ljmp $0x07c0, $0x0000

	/* === Procedure === */

.align 2 /* CarryFlag P_ResetDisk(void) */
P_ResetDisk:
	xorw %ax, %ax
	movw $0x0080, %dx
	int $0x13
	xorw %ax, %ax
	movw $0x0081, %dx
	int $0x13
	retw
1:
	.string "Disk reset error !\r\n"

.align 2 /* void P_Puts(%si) */
P_Puts:
	movb $0x0e, %ah
	movw $0x0700, %bx
0:
	lodsb
	orb %al, %al
	jz 0f
	int $0x10
	jmp 0b
0:
	retw

.align 2 /* %ax P_Puts(void) */
P_PressAnyKey:
	xorw %ax, %ax
	int $0x16
	retw

.align 2 /* reboot P_Error(%si) */
P_Error:
	callw P_Puts
	callw P_PressAnyKey
	int $0x18
	ljmp $0xffff, $0x0000
	retw

.align 4 /* User code */
	.long 0x97022744
P_UserCode:

	retw

.org 0x01be
L_PartitionTable_Start:
	.byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
L_PartitionTable_End:
	.word 0xaa55	
.align 2

.globl L_Entry

.end

/* End of source */
