/* 
  Copyright (c) 2004 JaeHyuk Cho <mailto:minzkn@infoeq.com>
  All right reserved.
*/

/*
  x86 16bit code library (Keyboard)
*/

/*
  - Interrupt $0x16
    + Function #0x00 : Get key
      %ah=$0x00
      <INT>
      %ah       : Scan code
      %al       : Ascii code
    + Function #0x01 : Get key status
      %ah=$0x01 
      <INT>
      Zero flag : $0=Key buffered, $1=Empty
      %ah       : Scan code
      %al       : Ascii code
*/

P_GetKey:                    /* %ax near16 P_GetKey(void) */
	xorb %ah, %ah
	int $0x16
	retw

P_GetKeyStatus:              /* Zero flag, %ax near16 P_GetKeyStatus(void) */
	movb $0x01, %ah
	int $0x16
	retw

/* End of source */
