/*
 Copyright (c) 2004 JaeHyuk Cho <mailto:minzkn@infoeq.com>
 All right reserved.
*/

#ifndef DEF_SOURCE_dump_c 
#define DEF_SOURCE_dump_c "dump.c"

#ifndef DEF_MACRO_PEEK
#define DEF_MACRO_PEEK (1)
#define __MZ_PEEK__(s_From, s_Offset) (((unsigned char *)(s_From)) + (s_Offset))
#define __MZ_PEEK_R__(s_From, s_Offset) (((unsigned char *)(s_From)) - (s_Offset))
#endif

#define DEF_DUMP_WIDTH ( 16 )
#define DEF_DUMP_CACHE ( 1 << 10 )

volatile void __mzstartup__(void);

static int __MZ_SystemCall__(int s_Number, int s_0, int s_1, int s_2);
static int __MZ_Dump_ConvertHexa__(void *s_String, int s_Value);
static void __MZ_Dump_Put__(const void *s_String, int s_Length);
static void __MZ_Dump_Hexa__(int s_Value, int s_Place);
static void __MZ_Dump__(int s_Offset, int s_Index, const void *s_Data, int s_Width);
static int __MZ_StringLength__(const char *s_String);
static void MZ_DumpEx(int s_Offset, const void *s_Data, int s_Size);
static int MZ_DumpFile(const char *s_FileName, int s_Offset, int s_Size);

int main(int s_Argc, char *s_Argv[]);

volatile void __mzstartup__(void)
{
 __asm__ volatile(
  "pushl %ebp\n\tmovl %esp, %ebp\n\tleal 0x0008(%ebp), %eax\n\t"
  "pushl %eax\n\tmovl 0x0004(%ebp), %eax\n\tpushl %eax\n\tcall main\n\t"
  "addl $8, %esp\n\tmovl %eax, %ebx\n\tmovl $1, %eax\n\tint $0x80\n\tpopl %ebp\n\t"
  "ret\n\t"
 );
}

static int __MZ_SystemCall__(int s_n, int s_0, int s_1, int s_2)
{ __asm__ volatile("int $0x80\n\t" : "=a"(s_n) : "a"(s_n), "b"(s_0), "c"(s_1), "d"(s_2)); return(s_n); }

static int __MZ_Dump_ConvertHexa__(void *s_String, int s_Value)
{
 const char c_HexaTable[] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
 char s_FILO[8];
 int s_Return, s_Index;
 for(s_Return = 0;s_Value > 0;s_FILO[s_Return++] = c_HexaTable[s_Value & 0x0f], s_Value >>= 4);
 for(s_Index = s_Return;s_Index > 0;*(((char *)s_String)++) = s_FILO[--s_Index]); 
 *((char *)s_String) = '\0';
 return(s_Return);
}

static void __MZ_Dump_Put__(const void *s_String, int s_Length)
{
 static char sg_Cache[ DEF_DUMP_CACHE ];
 static int  sg_Index = 0;
 if((s_Length == 0) || ((sg_Index + s_Length) > sizeof(sg_Cache)))
 {
  __MZ_SystemCall__(4, 1, (int)(&sg_Cache[0]), sg_Index);
  sg_Index = 0;
 }
 if(s_Length > 0)
 {
  if(s_Length >= sizeof(sg_Cache))__MZ_SystemCall__(4, 1, (int)s_String, s_Length);
  else
  {
   __asm__ volatile(
    "cld\n\tshrl $1, %2\n\tjnc 0f\n\tmovsb %%ds:(%1), %%es:(%0)\n\t"
    "0:\n\tshrl $1, %2\n\tjnc 0f\n\tmovsw %%ds:(%1), %%es:(%0)\n\t"
    "0:\n\trepz movsl %%ds:(%1), %%es:(%0)\n\t"
    : : "D"(&sg_Cache[sg_Index]), "S"(s_String), "c"(s_Length)
   );
   sg_Index += s_Length;
  }
 } 
}

static void __MZ_Dump_Hexa__(int s_Value, int s_Place)
{
 char s_Zero = '0', s_ConvertBuffer[8 + 1];
 int s_Length = __MZ_Dump_ConvertHexa__(&s_ConvertBuffer[0], s_Value), s_Index;
 s_Index = s_Length;
 while((s_Index++) < s_Place)__MZ_Dump_Put__(&s_Zero, sizeof(s_Zero));
 if(s_Length > 0)__MZ_Dump_Put__(&s_ConvertBuffer[0], s_Length);
}

static void __MZ_Dump__(int s_Offset, int s_Index, const void *s_Data, int s_Width)
{
 const char c_More[] = {' ', '|'}, c_Space = ' ', c_Dot = '.', c_NewLine = '\n';
 const char c_SpaceTable[] = {' ', ' ', ' ', ' ', ' '};	
 int s_Count;
 char s_Right[ 1 + 1 + DEF_DUMP_WIDTH + 1 + 1 ];	
 s_Right[0] = c_Space, s_Right[1] = '[', s_Right[ sizeof(s_Right) - 2 ] = ']', s_Right[ sizeof(s_Right) - 1 ] = c_NewLine;
 __MZ_Dump_Hexa__(s_Offset + s_Index, 8);
 for(s_Count = 0;s_Count < s_Width;s_Count++)
 {
  if(s_Count == (DEF_DUMP_WIDTH >> 1))__MZ_Dump_Put__(&c_More[0], sizeof(c_More));
  __MZ_Dump_Put__(&c_Space, sizeof(c_Space));
  s_Right[ s_Count + 2 ] = *((char *)__MZ_PEEK__(s_Data, s_Count));
  __MZ_Dump_Hexa__(s_Right[ s_Count + 2 ] & 0xff, 2);
  if(s_Right[ s_Count + 2 ] >= 0x7f || s_Right[ s_Count + 2 ] < c_Space)s_Right[ s_Count + 2 ] = c_Dot; 
 }
 for(;s_Count < DEF_DUMP_WIDTH;s_Count++)
 { 
  if(s_Count == (DEF_DUMP_WIDTH >> 1))__MZ_Dump_Put__(&c_SpaceTable[0], 2 + 3);
  else __MZ_Dump_Put__(&c_SpaceTable[0], 3);
  s_Right[ s_Count + 2 ] = c_Space; 
 } 
 __MZ_Dump_Put__(&s_Right[0], sizeof(s_Right));
}	

static int __MZ_StringLength__(const char *s_String)
{ int s_Return = 0; while(*(s_String + s_Return))s_Return++; return(s_Return); }

static void MZ_DumpEx(int s_Offset, const void *s_Data, int s_Size)
{
 int s_Index = 0, s_Width;
 while(s_Index < s_Size)
 {
  s_Width = s_Size - s_Index; 
  if(s_Width > DEF_DUMP_WIDTH)s_Width = DEF_DUMP_WIDTH;
  __MZ_Dump__(s_Offset, s_Index, __MZ_PEEK__(s_Data, s_Index), s_Width);  
  s_Index += DEF_DUMP_WIDTH;
 }
 __MZ_Dump_Put__((void *)0, 0); 
}

static int MZ_DumpFile(const char *s_FileName, int s_Offset, int s_Size)
{
 int s_Return, s_Handle, s_ReadBytes;
 unsigned char *s_Buffer[ DEF_DUMP_CACHE ];
 s_Return = (-1);
 if(s_FileName)
 {
  s_Handle = __MZ_SystemCall__(5, (int)s_FileName, 0, 0);
  if(s_Handle >= 0)
  {
   if(s_Offset > 0)__MZ_SystemCall__(19, s_Handle, s_Offset, 0);
   s_Return = 0;
   do
   {
    s_ReadBytes = __MZ_SystemCall__(3, s_Handle, (int)(&s_Buffer[0]), sizeof(s_Buffer));
    if(s_ReadBytes > 0)
    {
     MZ_DumpEx((s_Offset > 0 ? s_Offset : 0) + s_Return, &s_Buffer[0], s_ReadBytes);
     s_Return += s_ReadBytes;
    }
   }while(s_ReadBytes == sizeof(s_Buffer) && (s_Size < 0 || s_Return < s_Size)); 
   __MZ_SystemCall__(6, s_Handle, 0, 0);
  }
 }
 return(s_Return);
}

int main(int s_Argc, char *s_Argv[])
{
 const char c_Usage[] = {"Usage: dump <file>...\n"};
 int s_Index;
 if(s_Argc > 1)
 {
  for(s_Index = 1;s_Index < s_Argc;s_Index++)
  {
   __MZ_SystemCall__(4, 1, (int)(&s_Argv[s_Index][0]), __MZ_StringLength__(s_Argv[s_Index]));
   __MZ_SystemCall__(4, 1, (int)(&c_Usage[sizeof(c_Usage) - 2]), 1);
   (void)MZ_DumpFile(s_Argv[s_Index], (-1), (-1));
  }
 }
 else __MZ_SystemCall__(4, 1, (int)(&c_Usage[0]), sizeof(c_Usage) - 1);
 return(0);
}

#endif

/* End of source */
